//----------------------------------------------------------------------------------
// Module D17 par Jean-Michel Dubois
// Train management
//----------------------------------------------------------------------------------

#pragma once

#include "config.h"

#if PROTOCOLE == D17PPV3

class Cote;

class Train
{
public:
	Train();
	Train(unsigned int adresse, byte speedsteps, byte vmanoeuvre, 
		byte pas15, byte pas30, byte pas60, byte pas90, byte pas100, byte pas120, byte pas160, byte pas220, byte pas300, byte pas320, byte pasMax);
	Train(byte wagons);
	~Train();
	inline void ChangerVitesse(byte pas)
	{
		m_pasSouris = m_pasActuel = pas;
	}
	void ChangerSens(byte sens);
	inline void ChangerMarcheAVue(byte marche_a_vue)
	{
		m_marche_a_vue = marche_a_vue;
	}
	void RegulerVitesse(byte pas);
	void Ralentir(Cote* pCote);	// ralentit un train
	void ArreterOuRalentir(Cote* pCote);	// ralentit ou stoppe un train

	// constantes
	unsigned int m_adresse;	// adresse dcc
	byte m_pasDCC;		// 28 ou 126 pas
	byte m_vmanoeuvre;	// numro de fonction de la pas de manoeuvre
	byte m_pas15;		// pas DCC 15 km/h
	byte m_pas30;		// pas DCC 30 km/h
	byte m_pas60;		// pas DCC 60 km/h
	byte m_pas90;		// pas DCC 90 km/h
	byte m_pas100;		// pas DCC 100 km/h
	byte m_pas120;		// pas DCC 120 km/h
	byte m_pas160;		// pas DCC 160 km/h
	byte m_pas220;		// pas DCC 220 km/h
	byte m_pas300;		// pas DCC 300 km/h
	byte m_pas320;		// pas DCC 320 km/h
	byte m_pasMax;		// pas DCC de vitesse maxi
	// variables
	byte m_zone;		// zone actuelle = zone occupe la plus rcente
	byte m_sensAvant;	// sens en marche avant : SANS_SENS, SENS_PAIR, SENS_IMPAIR
	byte m_sensActuel;	// sens de marche actuel
	byte m_pasSouris;	// pas DCC de consigne de la souris
	byte m_pasActuel;	// pas DCC actuel aprs rduction ventuelle par la rgulation automatique
	byte m_wagons;		// nombre de wagons/voitures/autres locos remorqus
	bool m_manoeuvre;	// true si pas de manoeuvre active
	bool m_marche_a_vue;// true si le train est en marche  vue (outrepassement des signaux)
};

// Sens de marche, u = train passif, E = sens pair, O = sens impair

enum { SANS_SENS = 'u', SENS_PAIR = 'e', SENS_IMPAIR = 'o' };

constexpr auto DERNIER_ENGIN = 127;
constexpr auto INCONNU = 255;	// Train inconnu

#endif