//==============================================================================================
// Module D17 par Jean-Michel Dubois
// Suivi des trains et rgulation automatique
//==============================================================================================

#pragma once

#include "config.h"

#if PROTOCOLE == D17PPV3

#include "Zone.h"
#include "Train.h"
#include "signal.h"

class Block
{
public:
	Block() {};

	static void ChangeSignal(unsigned int numsignal, typeFeux _feux, typeRalenti _ralenti = VITESSE_NORMALE);
	static byte EtatSignal(unsigned int numsignal);
	static byte EtatRalentissement(unsigned int numsignal);
	static bool SignalFerme(byte nosignal);
	static bool SignalOuvert(byte nosignal);
	static bool SignalAvertissement(byte nosignal);
	static bool Signal15kmh(byte nosignal);
	static bool Signal160kmh(byte nosignal);
	static void Reguler(void);
	static void OnReguler(void);
	static void OnNotifyAig(byte naig, byte cmd); // cmd=0=direct cmd=1=devie;
	static void InitTco(void);
	static void OnNotifyU(byte num, byte val);
	static void OnZoneLiberer(byte zone);
	static void OnZoneOccuper(byte zone);
	static void UpdateZones(void);
	static bool ZoneOccupee(int zone) { return user_get_in(zone); }
	static bool ZoneLibre(int zone) { return !user_get_in(zone); }
	static void Liberer(byte zone);
	static void Occuper(byte zone);
	static void OnInit(void);
	static void OnNotifyTempoEnd(byte num);
	static void TracerItineraire(byte num);
	static void DetruireItineraire(byte num);
	static bool CantonOccupe(byte zone);
	static bool CantonLibre(byte zone) { return !CantonOccupe(zone); }
	static Train* FindTrainByAddress(unsigned int address);
	static Zone		m_Zones[];
	static Signal	m_Signaux[];
	static Train	m_Trains[256];
	static byte		m_uiZones;
	static byte		m_uiSignaux;

private:
	static void OnInitTco(void);
	static void BasculeAiguille(byte naig, byte cmd); // cmd=0=direct cmd=1=devie
};

#endif