//-----------------------------------------------------------------------
// Module D17 par Jean-Michel Dubois
// Macro commandes pour les accessoires
//-----------------------------------------------------------------------
#pragma once
#include "config.h"
#include "dcc.h"

// commands macroes
// acc = accessory number. use 1 number for a turnout, 2 for 3 way turnout, a single or a double slip

// direct pins of Wemos D1 mini
// pin1, pin2 = pin number, OUTn[D|E]
// val = 0 or 1

// Sortie continue.
#define DIRECT_SINGLE(acc, pin1, cmd)                             if (naig == acc) { TRACE1("acc %d direct, pin %d, cmd %d\n", naig, pin1, cmd); user_out(pin1, cmd); }
// Sortie impulsionnelle.
#define DIRECT_SINGLE_PULSE(acc, pin1, cmd, timer, duration)      if (naig == acc) { user_out(pin1, cmd); user_tempo_start(timer, duration); }
#define DIRECT_SINGLE_PULSE_END(timer, pin1)                      if (timer == num_tempo) user_out(pin1, 0); 
// Sortie directe
#define DIRECT_PAIR(acc, pin1, pin2, cmd)                         if (naig == acc) { \
                                                                    if (cmd) { \
																	  TRACE1("acc %d direct, pin %d, cmd 0, pin %d, cmd 1\n", naig, pin1, pin2);  \
                                                                      user_out(pin1, 0); user_out(pin2, 1); \
                                                                    } else { \
																	  TRACE1("acc %d direct, pin %d, cmd 0, pin %d, cmd 1\n", naig, pin2, pin1);  \
                                                                      user_out(pin2, 0); user_out(pin1, 1); \
                                                                    } \
                                                                  }
// Sortie en alternance  implusion.
#define DIRECT_PAIR_PULSE(acc, pin1, pin2, cmd, timer, duration)  if (naig == acc) { \
                                                                    if (cmd) { \
																	  TRACE1("acc %d direct, pin %d, cmd 0, pin %d, cmd 1, timer %d, duration %d\n", naig, pin1, pin2, timer, duration);  \
                                                                      user_out(pin1, 0); user_out(pin2, 1); \
                                                                      user_tempo_start(timer, duration); \
                                                                    } else { \
                                                                      user_out(pin2, 0); user_out(pin1, 1); \
																	  TRACE1("acc %d direct, pin %d, cmd 0, pin %d, cmd 1, timer %d, duration %d\n", naig, pin2, pin1, timer, duration);  \
                                                                      user_tempo_start(timer, duration); \
                                                                    } \
                                                                  }
#define DIRECT_PAIR_PULSE_END(timer, pin1, pin2)                  if (timer == num_tempo) { \
																	TRACE1("timer %d, pin %d, cmd 0, pin %d, cmd 0\n", timer, pin1, pin2); \
																	user_out(pin1, 0); user_out(pin2, 0); \
																  } 
// Sortie via dcodeur DCC basique.
#define DCC_BASIC(acc, adr, decout, cmd)                          if (naig == acc) { \
                                                                    if (! cmd) { \
																	  TRACE1("acc %d basic, adr %d, out %d, cmd 1\n", naig, adr, decout); \
                                                                      user_bas_acc_dec_tx(adr, decout, 1); \
                                                                    } else { \
                                                                      TRACE1("acc %d basic, adr %d, out %d, cmd 1\n", naig, adr, decout + 1); \
                                                                      user_bas_acc_dec_tx(adr, decout + 1, 1); \
                                                                    } \
                                                                  }
// Sortie via dcodeur DCC tendu.
#define DCC_EXTENDED(acc, adr, cmd)                               if (naig == acc) { TRACE1("acc %d ext, adr %d, cmd %d\n", acc, adr, cmd); user_ext_acc_dec_tx(adr, cmd); }

#if USER_USE_PCA
// fixed output
// adr1, adr2 = output number = 0 to 95
// cmd = 0 or 1

// Sortie simple via module PCA9685 sur bus I2C.
# define PWM_SINGLE(acc, adr1, cmd)                            if (naig == acc) user_pwm_0_100(adr1, cmd * 100);
# define PWM_SINGLE_PULSE(acc, adr1, cmd, timer, duration)     if (naig == acc) { user_pwm_0_100(adr1, cmd * 100); user_tempo_start(timer, duration); }
# define PWM_SINGLE_PULSE_END(timer, adr1)                     if (timer == num_tempo) user_pwm_0_100(adr1, 0);
// Sortie en alternance via module PCA9685 sur bus I2C.
# define PWM_PAIR(acc, adr1, adr2, cmd)                        if (naig == acc) { user_pwm_0_100(adr1, cmd * 100); user_pwm_0_100(adr2, 0); } \
                                                               if (naig == acc + 1) { user_pwm_0_100(adr2, cmd * 100); user_pwm_0_100(adr1, 0); } 
# define PWM_PAIR_PULSE(acc, adr1, adr2, cmd, timer, duration) if (naig == acc) { user_pwm_0_100(adr1, cmd * 100); user_pwm_0_100(adr2, 0); user_tempo_start(timer, duration); } \
                                                               if (naig == acc + 1) { user_pwm_0_100(adr2, cmd * 100); user_pwm_0_100(adr1, 0); user_tempo_start(timer, duration); }
# define PWM_PAIR_PULSE_END(timer, adr1, adr2)                 if (timer == num_tempo) { user_pwm_0_100(adr2, 0); user_pwm_0_100(adr1, 0); }

// servomotor
// adr = output number = 0 to 95
// cmd = 0 or 1

# define SERVO_INIT(acc, adr, width)  user_servo_500_2500(adr, 1000); user_servo_speed(adr, width);
# define SERVO_SINGLE(acc, adr, cmd)  if (naig == acc) { TRACE1("acc %d servo, adr %d, cmd %d\n", naig, adr, cmd ? 2000 : 1000); user_servo_500_2500(adr, cmd ? 2000 : 1000); }
# define SERVO_PAIR(acc, adr, cmd)    if (naig == acc && cmd) user_servo_500_2500(adr, 1000); \
                                     if (naig == acc + 1 && cmd) user_servo_500_2500(adr, 2000);
#endif  // USER_USE_PCA
