//--------------------------------------------------------------------------------
// Module D17 par Ulysse Delmas-Bgue et  la marge Jean-Michel Dubois
// Gnration du signal DCC
//--------------------------------------------------------------------------------

#pragma once

#include "config.h"

extern byte boost;
extern byte oldboost;
extern byte au;   //maintenant la centrale demarre en AU (donc alimenation off, cela est plus sure)  
extern byte pwmsens;
extern unsigned int pwm1024;
extern unsigned int cv_adr;
extern byte cv_dat;
extern unsigned int an;   //derniere lecture du convertisseur analogique/numerique

void dcc_tx2(byte p_len, byte a, byte c);
void dcc_tx3(byte p_len, byte a, byte b, byte c);
void dcc_keepalive(void);   //a appeller si une fonction dure plus de 9.9ms pour que les decodeurs restent en mode DCC
void prog_cv(unsigned int cv_adr, byte dat);

#if PRINT_PACKET
extern unsigned long int boosterloop;
#endif

//--------------------------------------------------------------------------------
// Booster management
//----------------------------------------------------------------------------------

class C_slot_ch   
{
    public:
        unsigned int adr = 0;
        byte sens = 0;
        byte vit = 0;
        byte fct[29] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};  //f0-f1---f28
        unsigned long msecs = 0;
#if PROTOCOLE == D17PPV3
		byte speedsteps;
#endif
        byte fct_0_4_modified = 0;
        byte fct_5_8_modified = 0;
        byte fct_9_12_modified = 0;
        byte fct_13_20_modified = 0;
        byte fct_21_28_modified = 0;
		byte vit_modified = 0;
};

extern unsigned int souris_adr[MAX_WIFI_CLIENTS][MAX_CHANNELS];  // stocke les adresses des locos pour chaque souris.
										  // afin de savoir s'il y a l'adresse 1 et passer en analogique
extern C_slot_ch slot_ch[NB_SLOTS];

void dcc_set_fct(byte slot, byte fct_num, byte val);
void booster_maj(void);
void dcc_tx4(byte p_len, byte a, byte b, byte c, byte d);
