#pragma once

#include "config.h"

#if PROTOCOLE == D17PPV2 || PROTOCOLE == D17PPV3 || PROTOCOLE == DSTATION

class Decoder
{
public:
	Decoder() { }
	static int m_uiResult;
	static bool m_fResult;
	static char m_cCode;
	static void Reset(byte num);
	static void Factory(void);
	static void DirectRead(unsigned int address);
	static void DirectReadBit(unsigned int address, byte bit);
	static void DirectVerify(unsigned int address, byte value);
	static void DirectWrite(unsigned int address, byte value);
	static void DirectWriteBit(unsigned int address, byte bit, bool value);
	static void PagedRead(unsigned int address);
	static void PagedVerify(unsigned int address, byte value);
	static void PagedWrite(unsigned int address, byte value);
private:
	static bool ReadAck(int reference, byte reset);
	static bool PagedVerify(byte cv_pag, byte cv_reg, byte value, unsigned int reference);
	static unsigned int MeanCurrent(void);
};

#endif