//------------------------------------------------------------------------------
// Module D17 par Ulysse Delmas-Bgue
// I2C (I2C fait a la main pour pouvoir utiliser une basse frequence et n'importe quelle patte)
//------------------------------------------------------------------------------

#include "i2c.h"

#if USER_USE_PCA

//on emule un collecteur ouvert en mettant les sorties a 0 et en jouant sur la direction.
#define SDA_1 pinMode(SDA_PIN, INPUT)
#define SDA_0 pinMode(SDA_PIN, OUTPUT)
#define SCK_1 pinMode(SCK_PIN, INPUT)
#define SCK_0 pinMode(SCK_PIN, OUTPUT)


void i2c_init(void)
{
    pinMode(SCK_PIN, INPUT); digitalWrite(SCK_PIN, LOW);
    pinMode(SDA_PIN, INPUT); digitalWrite(SDA_PIN, LOW); 
}


void i2c_start(void)
{
    SDA_1; SCK_1; delayMicroseconds(5);  
    SDA_0; delayMicroseconds(5);
    SCK_0; delayMicroseconds(5);  
}


void i2c_stop(void)
{
    SDA_0; SCK_0; delayMicroseconds(5);  
    SCK_1; delayMicroseconds(5);  
    SDA_1; delayMicroseconds(5);  
}


bool i2c_wr_8(byte data)
{
    byte i;

    for(i = 0; i < 8;i++)
    {
        if(data & 0x80) { SDA_1; } else { SDA_0; } delayMicroseconds(4);  
        SCK_1; delayMicroseconds(4);  
        SCK_0; delayMicroseconds(1);  
        data = data << 1;        
    }
    SDA_1; delayMicroseconds(1);
	
	
	if(i2c_rd_ack())
		return true;

	i2c_stop();
	return false;
}


byte i2c_rd_ack(void)
{
    byte ack;

    delayMicroseconds(4);  //before 0
    SCK_1; delayMicroseconds(4);  
	ack = (digitalRead(SDA_PIN) != HIGH);
    SCK_0; delayMicroseconds(1);  
    return ack;
}


byte i2c_rd_8(void)
{
    byte i, data;

    data = 0;
    for(i = 0; i < 8; i++)
    {
        data <<= 1;        
        delayMicroseconds(4);  //before 0
        SCK_1; delayMicroseconds(4);  
        if(digitalRead(SDA_PIN) == HIGH) data |= 1;  
        SCK_0; delayMicroseconds(1);  
    }
    return data;  
}


void i2c_wr_ack(byte ack)   //1=ack, 0=nack
{
    if(ack) { SDA_0; } else { SDA_1; } delayMicroseconds(4);  
    SCK_1; delayMicroseconds(4);  
    SCK_0; delayMicroseconds(1);
}

#endif
