//------------------------------------------------------------------------------
// Module D17 par Ulysse Delmas-Bgue et  la marge Jean-Michel Dubois
// Entres S88 et I2C
//------------------------------------------------------------------------------

#include "inputs.h"

#if USER_USE_S88 || USER_USE_MCPIN

# if USER_USE_S88
#  include "s88.h"
# endif
# if USER_USE_MCPIN
#  include "mcp23017.h"
# endif

byte io_in[IO_IN_NB / 8];     // 96 entrees
byte io_in_old[IO_IN_NB / 8];    // memorisation pour identifier les chnagements
byte io_inmem_wifi[MAX_WIFI_CLIENTS][IO_IN_NB / 8];  // memorisation des entrees pour chaque souris
byte io_inmem_usb[IO_IN_NB / 8];    //  memorisation des entrees pour un logiciel

void in_init(void)
{
	memset(io_in, 0, sizeof(io_in));
	memset(io_in_old, 0, sizeof(io_in_old));
	memset(io_inmem_wifi, 0, sizeof(io_inmem_wifi));
	memset(io_inmem_usb, 0, sizeof(io_inmem_usb));
# if USER_USE_MCPIN
	in_mcp23017_init();
# endif
}


byte user_get_in(byte num)
{
	if (num < IO_IN_NB) if (io_in[num / 8] & 1 << (num & 7)) return 1;

	return 0;
}

byte user_get_in_old(byte num)
{
	if (num < IO_IN_NB) if (io_in_old[num / 8] & 1 << (num & 7)) return 1;

	return 0;
}

void in_maj(void)
{
# if USER_USE_S88
	s88_maj();
# endif
# if USER_USE_MCPIN
	in_mcp23017_maj();
# endif
}

#endif
