//------------------------------------------------------------------------------
// Module D17 par Ulysse Delmas-Bgue et  la marge Jean-Michel Dubois
// Entres S88 et I2C
//------------------------------------------------------------------------------
#pragma once

#include "config.h"

#if USER_USE_S88 || USER_USE_MCPIN

# if USER_S88_MODULES < 0 || USER_S88_MODULES > 6
#  error "Number of S88 modules must be >= 0 and <= 6"
# endif

# if USER_MCP23017_IN_MODULES < 0 || USER_MCP23017_IN_MODULES > 6
#  error "Number of MCP23017 input modules must be be >= 0 and <= 6"
# endif

# if USER_S88_MODULES + USER_MCP23017_IN_MODULES > 6
#  error "Number of S88 + MCP23017 input modules must be be >= 0 and <= 6"
# endif

// number of input circuits. Do not change
constexpr auto IO_IN_NB = 96;
# define S88_IN_NB (USER_S88_MODULES * 16)
# define MCP23017_IN_NB (USER_MCP23017_IN_MODULES * 16)

extern byte io_in[IO_IN_NB / 8];     // 96 entrees
extern byte io_in_old[IO_IN_NB / 8];    // memorisation pour identifier les changements
extern byte io_inmem_wifi[MAX_WIFI_CLIENTS][IO_IN_NB / 8];  // memorisation des entrees pour chaque souris
extern byte io_inmem_usb[IO_IN_NB / 8];    //  memorisation des entrees pour un logiciel

void in_init(void);
void in_maj(void);
byte user_get_in(byte num);
byte user_get_in_old(byte num);

#endif