//------------------------------------------------------------------------------
// Module D17 par Ulysse Delmas-Bgue et Jean-Michel Dubois pour la partie MCP23017
// Sorties
//------------------------------------------------------------------------------

#include "outputs.h"
#if USER_USE_MCPOUT
# include "mcp23017.h"
#endif

void out_init(void)
{
	// pins init
	pinMode(P_PIN, OUTPUT); digitalWrite(P_PIN, LOW);  // D2
	pinMode(S_PIN, OUTPUT); digitalWrite(S_PIN, LOW);  // D3
	pinMode(LED_PIN, OUTPUT); digitalWrite(LED_PIN, HIGH);  // D4 LED active low, also LLED_PIN
	pinMode(DAT_PIN, OUTPUT); digitalWrite(DAT_PIN, LOW);  // D0
	pinMode(CLK_PIN, OUTPUT); digitalWrite(CLK_PIN, LOW);  // D5
	pinMode(LDIN_PIN, OUTPUT); digitalWrite(LDIN_PIN, LOW);  // D1
	pinMode(RST_PIN, OUTPUT); digitalWrite(RST_PIN, LOW);  // D8
	pinMode(SCK_PIN, OUTPUT); digitalWrite(SCK_PIN, LOW);  // D7
	pinMode(SDA_PIN, OUTPUT); digitalWrite(SDA_PIN, LOW);  // D6

#if USER_USE_MCPOUT
	out_mcp23017_init();
#endif
}

void user_out(byte num, byte val)
{
#if USER_USE_MCPOUT
	if (num < MCP23017_OUT_PIN_OFFSET) {
#endif
		if (val == 1) val = HIGH; else val = LOW;
#if USER_USE_PCA == 0 && USER_USE_MCPIN == 0 && USER_USE_MCPOUT == 0
		if (num == SDA_PIN) digitalWrite(SDA_PIN, val); //pin6
		if (num == SCK_PIN) digitalWrite(SCK_PIN, val); //pin7
#endif
#if USER_USE_S88 == 0
		if (num == LDIN_PIN) digitalWrite(LDIN_PIN, val); //pin1
		if (num == RST_PIN) digitalWrite(RST_PIN, val); //pin8
#endif
#if USER_USE_MAX == 0 && USER_USE_S88 == 0
		if (num == DAT_PIN) digitalWrite(DAT_PIN, val); //pin0
		if (num == CLK_PIN) digitalWrite(CLK_PIN, val); //pin5
#endif
#if USER_USE_MCPOUT
	}
	else {
		out_mcp23017(num, val);
	}
#endif
}




