//------------------------------------------------------------------------------
// Module D17 par Ulysse Delmas-Bgue
// S88 (96)
//------------------------------------------------------------------------------

#include "s88.h"

#if USER_USE_S88
# include "inputs.h"
# include "dcc.h"

#if USER_S88_MODULES > 6
# error "Number of S88 modules must be <= 6"
#endif

// utilisation de 25us sur S88 soit une periode de 50us et une frequence de 20kHz
// Cette basse frequence permet de fonctionner avec des uc qui emulent lentement le S88 au lieu des 4014/2021  
// Duree totale theorique pour 96 entrees: 4.8ms
static byte in_shift8(void)
{
    byte i, dat;

    for(i = dat = 0; i < 8; i++)
    {
        dat = dat >> 1;
        if(digitalRead(DAT_PIN) == HIGH) dat |= 0x80;
        digitalWrite(CLK_PIN, HIGH); delayMicroseconds(25); digitalWrite(CLK_PIN, LOW); delayMicroseconds(25);
    }
    return dat;    
}


void s88_maj(void)
{
    byte module, v;

    pinMode(DAT_PIN, INPUT);
    
    digitalWrite(CLK_PIN , LOW ); delayMicroseconds(25);  //mise a 0 car utilisee par d'autres fonctions qui peuvent l'avoir mise a 1
    digitalWrite(LDIN_PIN, HIGH); delayMicroseconds(25);
    digitalWrite(CLK_PIN , HIGH); delayMicroseconds(25);
    digitalWrite(CLK_PIN , LOW ); delayMicroseconds(25);
    digitalWrite(LDIN_PIN, LOW ); delayMicroseconds(25);
    digitalWrite(RST_PIN , HIGH); delayMicroseconds(25);
    digitalWrite(RST_PIN , LOW ); delayMicroseconds(25);
    
    for(module = 0; module < USER_S88_MODULES * 2; module++)
    {
        io_in_old[module] = io_in[module];
        io_in[module] = v = in_shift8();

		for (byte client = 0; client < MAX_WIFI_CLIENTS; ++client)
			io_inmem_wifi[client][module] |= v;

		io_inmem_usb[module] |= v;
		yield();
    } 
}

#endif
