#pragma once

#if PROTOCOLE == D17PPV3 || USER_USE_D19

typedef enum typeFeux {
	ETEINT = 0,
	VOIE_LIBRE = 1,
	AVERTISSEMENT = 2,
	SEMAPHORE = 4,
	CARRE = 5,
	MANOEUVRE = 6,
	CARRE_VIOLET = 7,
	CLIGNOTANT = 16,
	V160 = (VOIE_LIBRE | CLIGNOTANT),
	VOIE_LIBRE_CLIGNO = (VOIE_LIBRE | CLIGNOTANT),			// 160 km/h
	AVERTISSEMENT_CLIGNO = (AVERTISSEMENT | CLIGNOTANT),
	V15 = (SEMAPHORE | CLIGNOTANT),
	SEMAPHORE_CLIGNO = (SEMAPHORE | CLIGNOTANT),			// 15 km/h
	MANOEUVRE_CLIGNO = (MANOEUVRE | CLIGNOTANT)
} typeFeux;

typedef enum typeRalenti {
	VITESSE_NORMALE = 0,
	RALENTISSEMENT_30 = 1,
	RAPPEL_30 = 2,
	RALENTISSEMENT_60 = 3,
	RAPPEL_60 = 4
} typeRalenti;

class Signal {
public:
	Signal(void(*pSignal)(Signal*), unsigned int uiAdresse, byte bSignal)
	{
		m_pSignal = pSignal;
		m_uiAdresse = uiAdresse;
		m_bSignal = bSignal;
		m_Feux = ETEINT;
		m_Ralenti = VITESSE_NORMALE;
	}
	void(*m_pSignal)(Signal*);  // fonction de commande du signal
	unsigned int  m_uiAdresse;  // DCC : adresse DCC tendue. D19 : numro de module MAX7219 sur bus SPI 
	byte          m_bSignal;    // DCC : ignor.              D19 : numro de signal sur le module
	typeFeux      m_Feux;       // tat du feu principal
	typeRalenti   m_Ralenti;    // tat des feux de ralentissement
	bool		  m_fModifie[MAX_WIFI_CLIENTS];	// true si des informations de la zone ont t modifies depuis la dernire demande d'tat par chaque client
};

#endif