#include "slot.h"
#include "dcc.h"

// Algo pour grer les slots

byte first_slot = 0;  // slots le plus recement mis a jour
byte next_slot[NB_SLOTS];  // liste chainer des slots, du plus recent au plus vieux
					  // en dehors de la classe pour aller plus vite

#if PROTOCOLE == D17PPV2 || PROTOCOLE == D17PPV3

C_slot_ch* GetSlot(unsigned int adr)
{
	yield();

	for (byte i = 0; i < NB_SLOTS; i++)
		if (slot_ch[i].adr == adr)
			return &slot_ch[i];

	return NULL; // error
}

#endif

byte get_slot_for_adr(unsigned int adr)
{
	yield();

	for (byte i = 0; i < NB_SLOTS; i++)
		if (slot_ch[i].adr == adr)
			return i;

	return 99; // error
}

byte get_free_or_oldest_slot(void)
{
	byte i = first_slot;

	for (byte j = 0; j < NB_SLOTS; j++) {
		if (slot_ch[i].adr == 0) {
			return i; 
			/*Serial.print("NEW CH="); Serial.println(i);*/ 
		}

		if (j == (NB_SLOTS - 1))
			return i;

		i = next_slot[i];
	}

	yield();
	return 0; //never come here
}

void set_first_slot(byte slot)
{
	if (slot == first_slot) return;

	byte prev;
	for (byte j = 0; j < NB_SLOTS; j++) 
		if (next_slot[j] == slot) 
			prev = j;

	yield();

	next_slot[prev] = next_slot[slot];
	next_slot[slot] = first_slot;

	byte last = slot;

	for (byte j = 0; j < (NB_SLOTS - 1); j++) 
		last = next_slot[last];

	yield();

	next_slot[last] = slot;
	first_slot = slot;
}

void slots_init(void)
{
	for (byte i = 0; i < NB_SLOTS; i++) 
		next_slot[i] = i + 1;

	next_slot[NB_SLOTS - 1] = 0;


}

// ex de code PC pour une loco
/*
   printf("adr> "); scanf(" %d", &adr);
   slot = get_slot_for_adr(adr);     // <<<<< on regarde si elle existe deja
   if(slot == 99)
   {
		slot = get_free_or_older_ind();  // <<<<< si non on la rajoute sur un slot libre ou sur le plus vieux
		slot_ch[slot].adr = adr;
	}
	set_first_slot(slot);  // <<<<<< le slot de la loco devient le plus jeune
*/
