#pragma once

#include "config.h"

#if PROTOCOLE == D17PPV2 || PROTOCOLE == D17PPV3
#include "inputs.h"
#include "slot.h"

class Speed
{
public:
	Speed() {};
	static void MesureVitesse(byte train, unsigned int adresse, byte speedsteps, byte pas, byte zone, byte tour);
	static void MesureVitesse(void);

	static byte		m_ucTrain;			// Index du train dans la table des trains
	static byte		m_ucPas;			// Pas de vitesse DCC
	static bool		m_fEnMesure;		// true si mesure en cours.
	static bool		m_fMesureFaite;		// true si mesure termine.
	static unsigned long m_uiTemps;		// Temps de parcours en ms.
private:
	static C_slot_ch* m_pSlot;			// Slot du train. 
	static byte		m_ucZone;			// Zone de mesure.
	static byte		m_uiPhase;			// Phase de la mesure.
	static unsigned long m_uiStart;		// "Heure" de dbut de mesure.
	static unsigned long m_uiFreed;		// "Heure" de libration de la zone pour l'anti rebond.
};

#endif