//--------------------------------------------------------------------------------
// Module D17 par Ulysse Delmas-Bgue
// User tempos
//----------------------------------------------------------------------------------

#include "tempo.h"
#include "user.h"
#include "block.h"

constexpr auto TEMPO_NB = 80;  //mettre un multiple de 8

static unsigned int tempo_dcpt[TEMPO_NB];
static byte tempo_flag[TEMPO_NB / 8];

void user_tempo_start(byte num_tempo, unsigned int duration_ms)
{
	if (num_tempo >= TEMPO_NB) return;

	//tempo_dcpt[num_tempo] = duration_ms / 20; //20ms increment
	tempo_dcpt[num_tempo] = duration_ms / 250; //250ms increment
	if (duration_ms > 0 && duration_ms < 250) tempo_dcpt[num_tempo] = 1;

	if (duration_ms) 
		tempo_flag[num_tempo / 8] |= (1 << (num_tempo & 7));
	else
		tempo_flag[num_tempo / 8] &= (0xff ^ (1 << (num_tempo & 7)));
}


void tempo_maj(void)  //a appeller toutes les 250ms
{
	byte i, j, num;

	for (j = 0; j < (TEMPO_NB / 8); j++) {
		if (tempo_flag[j]) {
			for (i = 0; i < 8; i++) if (tempo_dcpt[i])
			{
				num = 8 * j + i;
				tempo_dcpt[num]--;

				if (tempo_dcpt[num] == 0) {
					tempo_flag[num / 8] &= (0xff ^ (1 << (num & 7)));
#if PROTOCOLE == D17PPV3
					if (fUseBlock)
						Block::OnNotifyTempoEnd(num);
					else
						on_notify_tempo_end(num);
#else
					on_notify_tempo_end(num);
#endif
				}
			}
		}
	}

	yield();
}
