//==============================================================================================
// Module D17 par Ulysse Delmas-Bègue
// USER PART
//==============================================================================================

#include "user.h"
#include "inputs.h"
#include "signal.h"
#include "turnout.h"
#include "protocol.h"
#include "dcc.h"

// User functions
void on_init(void)
{
	/*
	user_led_cli( 0,1);
	user_led_cli( 7,1); user_led_pha(7,1);
	user_led_cli(56,1); user_led_pha(56,1);
	user_led_cli(63,1);

	user_pwm_0_100( 0,   0);
	user_pwm_0_100( 1,  10);
	user_pwm_0_100( 2,  25);
	user_pwm_0_100( 3,  50);
	user_pwm_0_100( 4,  50);
	user_pwm_0_100( 5,  75);
	user_pwm_0_100( 6,  90);
	user_pwm_0_100( 7, 100);

	user_servo_500_2500( 8,  500);
	user_servo_500_2500( 9,  750);
	user_servo_500_2500(10, 1000);
	user_servo_500_2500(11, 1500);
	user_servo_500_2500(12, 1500);
	user_servo_500_2500(13, 2000);
	user_servo_500_2500(14, 2250);
	user_servo_500_2500(15, 2500);
	*/
}

#if PROTOCOLE <= D17PPV3

void on_notify_u(byte num, byte val)
{
	/*
	if(num==0) user_led(0,val);
	if(num==1) user_led(7,val);
	if(num==2) user_led(56,val);
	if(num==3) user_led(63,val);
	*/

	user_set_u(num, val);
}


void on_notify_aig(byte naig, byte cmd) // cmd=0=direct cmd=1=devie
{
	user_set_d_e(naig, 1 - cmd, cmd);
}

#endif

void on_notify_tempo_end(byte num_tempo)
{
}


void on_250ms()
{
}

#if PROTOCOLE == DCCPP

void user_dccpp_acc(int adr1_510, byte pair0_3, byte val0_1)
{
	if (val0_1) user_bas_acc_dec_tx(adr1_510, 2 * pair0_3 + 1, 1);
	else       user_bas_acc_dec_tx(adr1_510, 2 * pair0_3, 1);
}

#elif PROTOCOLE == DSTATION

void user_ds_acc(int acc1_320, byte val0_1)
{

	// acc1_320 = 1 --> adr = 1, pair = 0
	// acc1_320 = 2 --> adr = 1, pair = 1
	// acc1_320 = 3 --> adr = 1, pair = 2
	// acc1_320 = 4 --> adr = 1, pair = 3
	// acc1_320 = 5 --> adr = 2, pair = 0
	// ...
	// acc1_320 = 320 --> adr = 80, pair = 3

	unsigned int adr_dec_1_80 = (acc1_320 + 3) / 4;
	byte pair0_3 = (acc1_320 + 3) % 4;

	if (val0_1) user_bas_acc_dec_tx(adr_dec_1_80, 2 * pair0_3 + 1, 1);
	else       user_bas_acc_dec_tx(adr_dec_1_80, 2 * pair0_3, 1);
}

#elif PROTOCOLE == CDMRAIL

void user_cdm_acc(int acc1_2048, byte val0_1)
{
	// conversion faite par le code par defaut
	//     acc1_2048 = 1 --> adr = 1, pair = 0
	//     acc1_2048 = 2 --> adr = 1, pair = 1
	//     acc1_2048 = 3 --> adr = 1, pair = 2
	//     acc1_2048 = 4 --> adr = 1, pair = 3
	//     acc1_2048 = 5 --> adr = 2, pair = 0
	//     ...
	//     acc1_2048 = 2048 --> adr = 512, pair = 3

	unsigned int adr_dec_1_512 = (acc1_2048 + 3) / 4;
	byte pair0_3 = (acc1_2048 + 3) % 4;

	if (val0_1) user_bas_acc_dec_tx(adr_dec_1_512, 2 * pair0_3 + 1, 1);
	else       user_bas_acc_dec_tx(adr_dec_1_512, 2 * pair0_3, 1);
}

#endif