//==============================================================================================
//     USER PART
//==============================================================================================

#pragma once

#include "config.h"

//--------------------------------------------------------------------------------
// Code utilisateur (vous pouvez ajouter la gestion des accessoires
//----------------------------------------------------------------------------------

// functions available to user
void user_out(byte num, byte val);
void user_led(byte num, byte val);
void user_led_cli(byte num, byte val);
void user_led_pha(byte num, byte val);
void user_pwm_0_100(byte num, byte val);
void user_servo_500_2500(byte num, unsigned int val);
void user_servo_speed(byte num, byte speed);  //delta pulse us / 250ms 
void user_tempo_start(byte num_tempo, unsigned int duration_ms);
void user_set_d_e(byte num, byte val_d, byte val_e);
void user_set_u(byte num, byte val);
byte user_get_u(byte num);
byte user_get_aig(byte naig);
void user_bas_acc_dec_tx(unsigned adr, byte out, byte val);
void user_ext_acc_dec_tx(unsigned adr, byte val);
#if PROTOCOLE == DCCPP
void user_dccpp_acc(int adr1_510, byte pair0_3, byte val0_1);
#elif PROTOCOLE == DSTATION
void user_ds_acc(int acc1_320, byte val0_1);
#elif PROTOCOLE == CDMRAIL
void user_cdm_acc(int acc1_2048, byte val0_1);
#endif
// functions supplied by user
void on_init(void);
void on_notify_u(byte num, byte val);
void on_notify_aig(byte naig, byte cmd); // cmd=0=direct cmd=1=devie;
void on_notify_tempo_end(byte num_tempo);
void on_250ms();

// pairs pins
#if ! USER_USE_S88 && ! USER_USE_MAX
# define OUT0E D4
# define OUT0D D0
#endif
#if ! USER_USE_PCA
# define OUT1E D7
# define OUT1D D6
#endif


//==============================================================================================
//     END of USER PART
//==============================================================================================

