//----------------------------------------------------------------------------------
// Module D17 par Ulysse Delmas-Bgue
// Variables utilisateur
//----------------------------------------------------------------------------------

#include "uservars.h"

#if PROTOCOLE <= D17PPV3

byte var_u[VAR_U_NB / 8];   // 96 variables

void set_var_u(byte num, byte val)
{
	byte ind = num / 8;
	byte msk = 1 << (num & 3);

	if (num >= VAR_U_NB) return;
	if (val) var_u[ind] |= msk;
	else     var_u[ind] &= (0xff ^ msk);
}


void inv_var_u(byte num)
{
	if (num >= VAR_U_NB) return;

	byte ind = num / 8;
	byte msk = 1 << (num & 3);

	var_u[ind] ^= msk;
}


byte get_var_u(byte num)
{
	if (num >= VAR_U_NB) return 0;

	byte ind = num / 8;
	byte msk = 1 << (num & 3);

	return (var_u[ind] & msk) ? 1 : 0;
}


void user_set_u(byte num, byte val)
{
	if (num < VAR_U_NB) set_var_u(num, val);
}


byte user_get_u(byte num)
{
	if (num >= VAR_U_NB) return 0;
	return get_var_u(num);
}

#endif